package com.javahonk.messaging;

import static com.javahonk.messaging.LoadProperties.getPropKeyValue;

import javax.jms.Connection;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

import com.tibco.tibjms.TibjmsConnectionFactory;

public class JavaTibcoConsumer implements MessageListener{

	public static void main(String[] args) {
		
		JavaTibcoConsumer javaTibcoConsumer = new JavaTibcoConsumer();
		
		javaTibcoConsumer.startSubscriber();

	}

	private void startSubscriber() {
		
		Queue outputQueue;
		MessageConsumer msgConsumer;
		
		try {
			
			TibjmsConnectionFactory factory = new TibjmsConnectionFactory(getPropKeyValue("TIBCO_URL"));
			Connection connection = factory.createConnection(getPropKeyValue("SUB_USER_ID"), getPropKeyValue("SUB_PASS"));
			
			Session session = connection.createSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);
			
			outputQueue = session.createQueue(getPropKeyValue("TIBCO_QUEUE_NAME"));			
			msgConsumer = session.createConsumer(outputQueue);
			msgConsumer.setMessageListener(this);

	        connection.start();
			
		} catch (JMSException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void onMessage(Message msg) {
		
		try {
			
			TextMessage txtMsg = (TextMessage) msg;
			
			System.out.println("Received response: "+txtMsg.getText());
			
			System.out.println("Message type: "+msg.getJMSType());
			 
			System.out.println("Message details: "+txtMsg);			

		} catch (Exception e) {
			
			e.printStackTrace();
		}
		
	}

}
