package com.javahonk.messaging;

import javax.jms.Connection;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

import static com.javahonk.messaging.LoadProperties.*;

import com.tibco.tibjms.TibjmsConnectionFactory;

public class JavaTibcoPublisher {
	
	public static void main(String[] args) throws InterruptedException {
		
		try {
			
			TibjmsConnectionFactory factory = new TibjmsConnectionFactory(getPropKeyValue("TIBCO_URL"));
			Connection connection = factory.createConnection(getPropKeyValue("PUB_USER_ID"), getPropKeyValue("PUB_PASS"));
			
			Session session = connection.createSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);
			
			Queue outputQueue = session.createQueue(getPropKeyValue("TIBCO_QUEUE_NAME"));
			MessageProducer msgProducer = session.createProducer(outputQueue);
			
			connection.start();
			
			TextMessage msg = session.createTextMessage("Send message on Ticco queue.");
            msg.setJMSType("Test.Data");
           
            for (int i = 0; i < 15; i++) {
            	msgProducer.send(msg);
            	Thread.sleep(1000);
			}
            
			
		} catch (JMSException e) {
			e.printStackTrace();
		}

	}	
	
}
